%% run simulation!!
global num_k
global Rinf
global m_sim
global k_sim
global Dw
global Fw

X_vec = zeros(2, num_jumps);
U_vec = zeros(2, num_jumps);

% storage
X_vec(:,1) = Xn;
U_vec(:,1) = Un;

%%
eta_i = 1:num_k;
phi_i = eta_i + num_k;

waves = [eta_h; phi_h];
z = zeros(num_k, 1);

bes_deriv = 1/2 * (besselj(m_sim-1, k_sim * Rinf) - besselj(m_sim+1, k_sim * Rinf));
norm_mat  = 1/2 * (Rinf * bes_deriv).^2;
P_mat     = 1./(2*pi * norm_mat);

%%
tic,
for ii = 1:num_jumps
    if mod(ii,1000) == 0
        disp(['Simulation ' num2str(ii/num_jumps*100) '% complete'])
    end
    % update droplet positions in Cartesians
    Xnp = Xn + Un;
    
    % find polar coordinates for droplet position
    [th, r] = cart2pol(Xnp(1),Xnp(2));
    bes_mat = besselj(m_sim, k_sim * r);
    
    % evolve waves and apply wave jumps
    for ss = 1:num_m
        waves(:,ss) = Mat_cell{ss} * waves(:,ss) - ...
            [z; P_mat(:,ss) .* bes_mat(:, ss) .* exp(-1i * m_sim(:,ss) * th)];
    end
    eta_h = waves(eta_i,:);
    phi_h = waves(phi_i,:);
    
    grad_np = get_grad_wavefield(r, th, eta_h);
    Unp = Un - (Dw*Un  +  Fw*grad_np);
    
    % storage
    X_vec(:,ii) = Xnp;
    U_vec(:,ii) = Unp;
    
    % update variables
    Xn = Xnp;
    Un = Unp;
end
toc

